/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2021  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.lobby.portal;

import java.util.Map;
import java.util.function.BiFunction;

public enum PortalType {
    TELEPORT(TeleportPortal::new),
    COMMAND(CommandPortal::new),
    FIGHTSERVER(FightserverPortal::new),
    DUMMY(DummyPortal::new),
    STACK(StackPortal::new);

    private final BiFunction<Map<String, Object>, Portal, PortalHandler> deserializer;

    PortalType(BiFunction<Map<String, Object>, Portal, PortalHandler> deserializer) {
        this.deserializer = deserializer;
    }

    public PortalHandler deserialize(Map<String, Object> map, Portal portal) {
        return deserializer.apply(map, portal);
    }
}
